/** 
 * @author Eugene Turkov
 * @author <a href="mailto:eugene.turkov@nasa.gov">eugene.turkov@nasa.gov</a>
 * @version: 1.0
 * @since SDK1.5
 * 
 * NASA Ames Research Center Computational Sciences Division Intelligent Data
 * Understanding Group (IDU) Moffett Field, CA 94035
 */
package turkov.util;

import java.util.HashMap;
import java.util.Vector;

public abstract class TUSequenceUtil
{
	public static Object[] applyRemovals(final Object[] sequence,
			final TUSequenceAlteration[] sequenceAlterations)
	{
		Vector temp = new Vector();
		HashMap originalLocationsToNewLocations = new HashMap();
		for (int i = 0; i < sequence.length; i++)
		{
			temp.add(sequence[i]);
			originalLocationsToNewLocations.put(new Integer(i), new Integer(i));
			//System.out.println("temp[" + i + "] = " + temp.get(i));
		}

		for (int i = 0; i < sequenceAlterations.length; i++)
		{
			Object remove = sequenceAlterations[i].getObject();
			Integer locationToRemoveAt = new Integer(sequenceAlterations[i]
					.getIndex());
			//System.out.println("location to remove at: " + locationToRemoveAt);
			int actualRemovalPoint = ((Integer) originalLocationsToNewLocations
					.get(locationToRemoveAt)).intValue();

			/*
			if(actualRemovalPoint > temp.size())
			    temp.setSize(actualRemovalPoint + 1);
			 */

			//System.out.println("removing at location: " + actualRemovalPoint);
			//System.out.println("before removal we have: " + TUStringBuilder.concatenate(temp.toArray()));
			//while(true)
			{
				//try
				{
					//System.out.println("the object to remove is: " + remove + " at location: " + actualRemovalPoint);
					temp.removeElementAt(actualRemovalPoint);
					//break;
				}

				// catch(ArrayIndexOutOfBoundsException e)
				{
					//temp.setSize(temp.size() + 1);

					// System.out
				}
			}

			//System.out.println("after removal we have: " + TUStringBuilder.concatenate(temp.toArray()));

			//update the mapping
			for (int j = sequence.length - 1; j >= locationToRemoveAt
					.intValue(); j--)
			{
				Integer jay = new Integer(j);
				/*
				if(j == 4)
				    System.out.println("!! " + originalLocationsToNewLocations.get(new Integer(4)));
				 */
				/*
				System.out.println("before updated mapping: " + j
				+ " --> " + originalLocationsToNewLocations
				        .get(jay));
				 */
				originalLocationsToNewLocations.put(jay, new Integer(
						((Integer) (originalLocationsToNewLocations.get(jay)))
								.intValue() - 1));
				/*
				System.out.println("after updated mapping: " + j
				+ " --> " + originalLocationsToNewLocations
				        .get(jay));              
				 */
			}

		}

		Object[] result = new Object[temp.size()];
		for (int i = 0; i < result.length; i++)
		{
			result[i] = temp.get(i);
			//System.out.println(temp.get(i));
		}

		return result;
	}

	public static Object[] applyAdditions(Object[] sequence,
			TUSequenceAlteration[] sequenceAlterations)
	{

		Vector temp = new Vector();
		HashMap originalLocationsToNewLocations = new HashMap();
		for (int i = 0; i < sequence.length; i++)
		{
			temp.add(sequence[i]);
			originalLocationsToNewLocations.put(new Integer(i), new Integer(i));
			//System.out.println("temp[" + i + "] = " + temp.get(i));
		}

		//System.out.println("the sequence length is : " + sequence.length);
		originalLocationsToNewLocations.put(new Integer(sequence.length),
				new Integer(sequence.length));
		//System.out.println("just put " + originalLocationsToNewLocations.get(new Integer(sequence.length)));

		for (int i = 0; i < sequenceAlterations.length; i++)
		{
			Object objectToInsert = sequenceAlterations[i].getObject();
			Integer locationToInsertAt = new Integer(sequenceAlterations[i]
					.getIndex());

			//System.out.println("a test: " + locationToInsertAt);

			int actualInsertionPoint = ((Integer) originalLocationsToNewLocations
					.get(locationToInsertAt)).intValue();

			/*
			if(actualInsertionPoint > temp.size())
			    temp.setSize(actualInsertionPoint + 1);
			 */

			//System.out.println("inserting at location: " + actualInsertionPoint);
			//System.out.println("before insertion we have: " + TUStringBuilder.concatenate(temp.toArray()));
			while (true)
			{
				try
				{
					//System.out.println("the object to insert is: " + objectToInsert + " at location: " + actualInsertionPoint);
					temp.insertElementAt(objectToInsert, actualInsertionPoint);
					break;
				}

				catch (ArrayIndexOutOfBoundsException e)
				{
					temp.setSize(temp.size() + 1);
				}
			}

			//System.out.println("after insertion we have: " + TUStringBuilder.concatenate(temp.toArray()));

			//update the mapping
			for (int j = locationToInsertAt.intValue(); j < temp.size(); j++)
			{
				Integer jay = new Integer(j);
				/*
				if(j == 4)
				    System.out.println("!! " + originalLocationsToNewLocations.get(new Integer(4)));
				
				System.out.println("before updated mapping: " + j
				+ " --> " + originalLocationsToNewLocations
				        .get(jay));
				 */

				if (originalLocationsToNewLocations.get(jay) != null)
				{
					originalLocationsToNewLocations.put(jay, new Integer(
							((Integer) (originalLocationsToNewLocations
									.get(jay))).intValue() + 1));
				}

				else
				{
					originalLocationsToNewLocations.put(jay, new Integer(
							((Integer) (originalLocationsToNewLocations
									.get(new Integer(j - 1)))).intValue() + 1));
				}
				/*
				System.out.println("after updated mapping: " + j
				+ " --> " + originalLocationsToNewLocations
				        .get(jay));              
				 */
			}

		}

		Object[] result = new Object[temp.size()];
		for (int i = 0; i < result.length; i++)
		{
			result[i] = temp.get(i);
			//System.out.println(temp.get(i));
		}

		return result;
	}
}
